export declare class BigInt128Array {
    static of(...items: bigint[]): BigInt128Array;
    static from(arrayLike: ArrayLike<bigint>): BigInt128Array;
    static from<U>(arrayLike: ArrayLike<U>, mapfn: (v: U, k: number) => bigint, thisArg?: any): BigInt128Array;
    readonly BYTES_PER_ELEMENT: number;
    readonly buffer: ArrayBufferLike;
    readonly byteLength: number;
    readonly byteOffset: number;
    constructor(length?: number);
    constructor(array: Iterable<bigint>);
    constructor(buffer: ArrayBufferLike, byteOffset?: number, length?: number);
    get length(): number;
    set(array: ArrayLike<bigint>, offset?: number): void;
    at(index: number): bigint;
    subarray(begin?: number, end?: number): BigInt128Array;
    [Symbol.iterator](): {
        next(): {
            value: bigint;
            done: boolean;
        } | {
            done: boolean;
            value?: undefined;
        };
    };
    toString(): string;
}
