export declare const nulls: {
    readonly int8: -128;
    readonly int16: -32768;
    readonly int32: -2147483648;
    readonly int64: -9223372036854775808n;
    readonly int128: -170141183460469231731687303715884105728n;
    readonly float32: -3.4028234663852886e+38;
    /** -Number.MAX_VALUE */
    readonly double: number;
    readonly bytes16: Uint8Array;
};
export declare enum DdbForm {
    scalar = 0,
    vector = 1,
    pair = 2,
    matrix = 3,
    set = 4,
    dict = 5,
    table = 6,
    chart = 7,
    /** 结点内部通信可能会使用，调用函数执行脚本一般不会返回这种类型
        Node internal communication may be used, calling function execution script generally does not return this type */
    chunk = 8,
    /** sysobj */
    object = 9
}
/** DolphinDB DataType
    对应的 array vector 类型为 64 + 基本类型  The corresponding array vector type is 64 + base type
    对应的 extended 类型为 128 + 基本类型  The corresponding extended type is 128 + base type */
export declare enum DdbType {
    void = 0,
    bool = 1,
    char = 2,
    short = 3,
    int = 4,
    long = 5,
    date = 6,
    month = 7,
    time = 8,
    minute = 9,
    second = 10,
    datetime = 11,
    timestamp = 12,
    nanotime = 13,
    nanotimestamp = 14,
    float = 15,
    double = 16,
    symbol = 17,
    string = 18,
    uuid = 19,
    functiondef = 20,
    handle = 21,
    code = 22,
    datasource = 23,
    resource = 24,
    any = 25,
    compress = 26,
    dict = 27,
    datehour = 28,
    ipaddr = 30,
    int128 = 31,
    blob = 32,
    complex = 34,
    point = 35,
    duration = 36,
    decimal32 = 37,
    decimal64 = 38,
    decimal128 = 39,
    object = 40,
    pynone = 41,
    symbol_extended = 145
}
export declare enum DdbFunctionType {
    SystemFunc = 0,
    SystemProc = 1,
    OperatorFunc = 2,
    UserDefinedFunc = 3,
    PartialFunc = 4,
    DynamicFunc = 5,
    PiecewiseFunc = 6,
    JitFunc = 7,
    JitPartialFunc = 8
}
export declare enum DdbDurationUnit {
    ns = 0,
    us = 1,
    ms = 2,
    s = 3,
    m = 4,
    H = 5,
    d = 6,
    w = 7,
    M = 8,
    y = 9,
    B = 10
}
export declare enum DdbChartType {
    area = 0,
    bar = 1,
    column = 2,
    histogram = 3,
    line = 4,
    pie = 5,
    scatter = 6,
    trend = 7,
    kline = 8
}
