export const nulls = {
    int8: -0x80,
    int16: -0x80_00,
    int32: -0x80_00_00_00,
    int64: -0x8000000000000000n,
    int128: -0x80000000000000000000000000000000n,
    float32: -3.4028234663852886e+38,
    /** -Number.MAX_VALUE */
    double: -Number.MAX_VALUE,
    bytes16: Uint8Array.from(new Array(16).fill(0))
};
export var DdbForm;
(function (DdbForm) {
    DdbForm[DdbForm["scalar"] = 0] = "scalar";
    DdbForm[DdbForm["vector"] = 1] = "vector";
    DdbForm[DdbForm["pair"] = 2] = "pair";
    DdbForm[DdbForm["matrix"] = 3] = "matrix";
    DdbForm[DdbForm["set"] = 4] = "set";
    DdbForm[DdbForm["dict"] = 5] = "dict";
    DdbForm[DdbForm["table"] = 6] = "table";
    DdbForm[DdbForm["chart"] = 7] = "chart";
    /** 结点内部通信可能会使用，调用函数执行脚本一般不会返回这种类型
        Node internal communication may be used, calling function execution script generally does not return this type */
    DdbForm[DdbForm["chunk"] = 8] = "chunk";
    /** sysobj */
    DdbForm[DdbForm["object"] = 9] = "object";
})(DdbForm || (DdbForm = {}));
/** DolphinDB DataType
    对应的 array vector 类型为 64 + 基本类型  The corresponding array vector type is 64 + base type
    对应的 extended 类型为 128 + 基本类型  The corresponding extended type is 128 + base type */
export var DdbType;
(function (DdbType) {
    DdbType[DdbType["void"] = 0] = "void";
    DdbType[DdbType["bool"] = 1] = "bool";
    DdbType[DdbType["char"] = 2] = "char";
    DdbType[DdbType["short"] = 3] = "short";
    DdbType[DdbType["int"] = 4] = "int";
    DdbType[DdbType["long"] = 5] = "long";
    DdbType[DdbType["date"] = 6] = "date";
    DdbType[DdbType["month"] = 7] = "month";
    DdbType[DdbType["time"] = 8] = "time";
    DdbType[DdbType["minute"] = 9] = "minute";
    DdbType[DdbType["second"] = 10] = "second";
    DdbType[DdbType["datetime"] = 11] = "datetime";
    DdbType[DdbType["timestamp"] = 12] = "timestamp";
    DdbType[DdbType["nanotime"] = 13] = "nanotime";
    DdbType[DdbType["nanotimestamp"] = 14] = "nanotimestamp";
    DdbType[DdbType["float"] = 15] = "float";
    DdbType[DdbType["double"] = 16] = "double";
    DdbType[DdbType["symbol"] = 17] = "symbol";
    DdbType[DdbType["string"] = 18] = "string";
    DdbType[DdbType["uuid"] = 19] = "uuid";
    DdbType[DdbType["functiondef"] = 20] = "functiondef";
    DdbType[DdbType["handle"] = 21] = "handle";
    DdbType[DdbType["code"] = 22] = "code";
    DdbType[DdbType["datasource"] = 23] = "datasource";
    DdbType[DdbType["resource"] = 24] = "resource";
    DdbType[DdbType["any"] = 25] = "any";
    DdbType[DdbType["compress"] = 26] = "compress";
    DdbType[DdbType["dict"] = 27] = "dict";
    DdbType[DdbType["datehour"] = 28] = "datehour";
    DdbType[DdbType["ipaddr"] = 30] = "ipaddr";
    DdbType[DdbType["int128"] = 31] = "int128";
    DdbType[DdbType["blob"] = 32] = "blob";
    DdbType[DdbType["complex"] = 34] = "complex";
    DdbType[DdbType["point"] = 35] = "point";
    DdbType[DdbType["duration"] = 36] = "duration";
    DdbType[DdbType["decimal32"] = 37] = "decimal32";
    DdbType[DdbType["decimal64"] = 38] = "decimal64";
    DdbType[DdbType["decimal128"] = 39] = "decimal128";
    DdbType[DdbType["object"] = 40] = "object";
    DdbType[DdbType["pynone"] = 41] = "pynone";
    DdbType[DdbType["symbol_extended"] = 145] = "symbol_extended";
})(DdbType || (DdbType = {}));
export var DdbFunctionType;
(function (DdbFunctionType) {
    DdbFunctionType[DdbFunctionType["SystemFunc"] = 0] = "SystemFunc";
    DdbFunctionType[DdbFunctionType["SystemProc"] = 1] = "SystemProc";
    DdbFunctionType[DdbFunctionType["OperatorFunc"] = 2] = "OperatorFunc";
    DdbFunctionType[DdbFunctionType["UserDefinedFunc"] = 3] = "UserDefinedFunc";
    DdbFunctionType[DdbFunctionType["PartialFunc"] = 4] = "PartialFunc";
    DdbFunctionType[DdbFunctionType["DynamicFunc"] = 5] = "DynamicFunc";
    DdbFunctionType[DdbFunctionType["PiecewiseFunc"] = 6] = "PiecewiseFunc";
    DdbFunctionType[DdbFunctionType["JitFunc"] = 7] = "JitFunc";
    DdbFunctionType[DdbFunctionType["JitPartialFunc"] = 8] = "JitPartialFunc";
})(DdbFunctionType || (DdbFunctionType = {}));
export var DdbDurationUnit;
(function (DdbDurationUnit) {
    DdbDurationUnit[DdbDurationUnit["ns"] = 0] = "ns";
    DdbDurationUnit[DdbDurationUnit["us"] = 1] = "us";
    DdbDurationUnit[DdbDurationUnit["ms"] = 2] = "ms";
    DdbDurationUnit[DdbDurationUnit["s"] = 3] = "s";
    DdbDurationUnit[DdbDurationUnit["m"] = 4] = "m";
    DdbDurationUnit[DdbDurationUnit["H"] = 5] = "H";
    DdbDurationUnit[DdbDurationUnit["d"] = 6] = "d";
    DdbDurationUnit[DdbDurationUnit["w"] = 7] = "w";
    DdbDurationUnit[DdbDurationUnit["M"] = 8] = "M";
    DdbDurationUnit[DdbDurationUnit["y"] = 9] = "y";
    DdbDurationUnit[DdbDurationUnit["B"] = 10] = "B";
})(DdbDurationUnit || (DdbDurationUnit = {}));
export var DdbChartType;
(function (DdbChartType) {
    DdbChartType[DdbChartType["area"] = 0] = "area";
    DdbChartType[DdbChartType["bar"] = 1] = "bar";
    DdbChartType[DdbChartType["column"] = 2] = "column";
    DdbChartType[DdbChartType["histogram"] = 3] = "histogram";
    DdbChartType[DdbChartType["line"] = 4] = "line";
    DdbChartType[DdbChartType["pie"] = 5] = "pie";
    DdbChartType[DdbChartType["scatter"] = 6] = "scatter";
    DdbChartType[DdbChartType["trend"] = 7] = "trend";
    DdbChartType[DdbChartType["kline"] = 8] = "kline";
})(DdbChartType || (DdbChartType = {}));
//# sourceMappingURL=constants.js.map